import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:dotup_flutter_widgets/dotup_flutter_widgets.dart';

const pageSize = 20;

const simulatedDelay = 2;

final source = List<String>.generate(10000, (i) => 'Item $i');

class InfiniteScrollFutureExample extends StatefulWidget {
  InfiniteScrollFutureExample({Key? key}) : super(key: key);

  @override
  State<InfiniteScrollFutureExample> createState() => _InfiniteScrollFutureExampleState();
}

class _InfiniteScrollFutureExampleState extends State<InfiniteScrollFutureExample> {
  // final _scrollController = new ScrollController();
  late List<String> _currentItems;
  late bool isLoading;

  @override
  void initState() {
    super.initState();
    isLoading = false;
    _currentItems = source.take(pageSize).toList();
  }

  @override
  Widget build(BuildContext context) {
    const title = 'Long List';

    return Scaffold(
      appBar: AppBar(
        title: const Text(title),
      ),
      body: Stack(
        children: [
          if (isLoading == true) LinearProgressIndicator(),
          InfiniteScrollFuture(
            // scrollController: _scrollController,
            onReloadRequest: () async {
              setState(() {
                isLoading = true;
              });

              await Future.delayed(Duration(seconds: simulatedDelay));
              if (mounted) {
                setState(() {
                  _currentItems += source.skip(_currentItems.length).take(pageSize).toList();
                  print('reload: ${_currentItems.length}');
                  isLoading = false;
                });
              }
            },
            builder: (context, scrollController) {
              return ListView.builder(
                controller: scrollController,
                itemCount: _currentItems.length,
                itemBuilder: (context, index) {
                  return ListTile(
                    title: Text(_currentItems[index]),
                  );
                },
              );
            },
          ),
        ],
      ),
    );
  }
}
